public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
* [gentoo-commits] proj/sci:master commit in: dev-libs/boost/, dev-libs/boost/files/
@ 2021-01-20 16:11 Benda XU
  0 siblings, 0 replies; 3+ messages in thread
From: Benda XU @ 2021-01-20 16:11 UTC (permalink / raw
  To: gentoo-commits

commit:     039ea03a7621f7dfc1f3160d5632f47441d38692
Author:     Benda Xu <heroxbd <AT> gentoo <DOT> org>
AuthorDate: Wed Jan 20 06:26:40 2021 +0000
Commit:     Benda XU <heroxbd <AT> gentoo <DOT> org>
CommitDate: Wed Jan 20 16:11:24 2021 +0000
URL:        https://gitweb.gentoo.org/proj/sci.git/commit/?id=039ea03a

dev-libs/boost: add back 1.72.* for MIOpen.

AMD MIOpen depends on boost 1.72.* which has been remove from ::gentoo.

Suggested-by: Yiyang Wu <xgreenlandforwyy <AT> gmail.com>
Package-Manager: Portage-3.0.12, Repoman-3.0.1
Signed-off-by: Benda Xu <heroxbd <AT> gentoo.org>

 dev-libs/boost/boost-1.72.0-r2.ebuild              | 358 +++++++++++++++++++++
 .../files/boost-1.72.0-boost-mpi-python.patch      |  50 +++
 ...issing-serialization-split_member-include.patch |  29 ++
 ...t-1.72.0-revert-cease-dependence-on-range.patch |  49 +++
 dev-libs/boost/metadata.xml                        |  21 ++
 5 files changed, 507 insertions(+)

diff --git a/dev-libs/boost/boost-1.72.0-r2.ebuild b/dev-libs/boost/boost-1.72.0-r2.ebuild
new file mode 100644
index 000000000..542a589dd
--- /dev/null
+++ b/dev-libs/boost/boost-1.72.0-r2.ebuild
@@ -0,0 +1,358 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+PYTHON_COMPAT=( python3_{7,8} )
+
+inherit flag-o-matic multiprocessing python-r1 toolchain-funcs multilib-minimal
+
+MY_PV="$(ver_rs 1- _)"
+MAJOR_V="$(ver_cut 1-2)"
+
+DESCRIPTION="Boost Libraries for C++"
+HOMEPAGE="https://www.boost.org/"
+SRC_URI="https://dl.bintray.com/boostorg/release/${PV}/source/boost_${MY_PV}.tar.bz2"
+
+LICENSE="Boost-1.0"
+SLOT="0/${PV}" # ${PV} instead ${MAJOR_V} due to bug 486122
+KEYWORDS="~amd64"
+IUSE="bzip2 context debug doc icu lzma +nls mpi numpy python static-libs +threads tools zlib zstd"
+REQUIRED_USE="
+	mpi? ( threads )
+	python? ( ${PYTHON_REQUIRED_USE} )"
+
+# the tests will never fail because these are not intended as sanity
+# tests at all. They are more a way for upstream to check their own code
+# on new compilers. Since they would either be completely unreliable
+# (failing for no good reason) or completely useless (never failing)
+# there is no point in having them in the ebuild to begin with.
+RESTRICT="test"
+
+RDEPEND="
+	!app-admin/eselect-boost
+	!dev-libs/boost-numpy
+	bzip2? ( app-arch/bzip2:=[${MULTILIB_USEDEP}] )
+	icu? ( >=dev-libs/icu-3.6:=[${MULTILIB_USEDEP}] )
+	!icu? ( virtual/libiconv[${MULTILIB_USEDEP}] )
+	lzma? ( app-arch/xz-utils:=[${MULTILIB_USEDEP}] )
+	mpi? ( >=virtual/mpi-2.0-r4[${MULTILIB_USEDEP},cxx,threads] )
+	python? (
+		${PYTHON_DEPS}
+		numpy? ( $(python_gen_cond_dep 'dev-python/numpy[${PYTHON_USEDEP}]' -3) )
+	)
+	zlib? ( sys-libs/zlib:=[${MULTILIB_USEDEP}] )
+	zstd? ( app-arch/zstd:=[${MULTILIB_USEDEP}] )"
+DEPEND="${RDEPEND}"
+BDEPEND="=dev-util/boost-build-${MAJOR_V}*"
+
+S="${WORKDIR}/${PN}_${MY_PV}"
+
+PATCHES=(
+	"${FILESDIR}"/${PN}-1.71.0-disable_icu_rpath.patch
+	"${FILESDIR}"/${PN}-1.71.0-context-x32.patch
+	"${FILESDIR}"/${PN}-1.71.0-build-auto_index-tool.patch
+	# Bug 703294, incomplete Boost.Serialization refactoring
+	"${FILESDIR}"/${PN}-1.72.0-missing-serialization-split_member-include.patch
+	# Bug 703036, per python-impl Boost.MPI
+	"${FILESDIR}"/${PN}-1.72.0-boost-mpi-python.patch
+	# Bug 704128, missing include on Boost.Ranges
+	"${FILESDIR}"/${PN}-1.72.0-revert-cease-dependence-on-range.patch
+)
+
+python_bindings_needed() {
+	multilib_is_native_abi && use python
+}
+
+tools_needed() {
+	multilib_is_native_abi && use tools
+}
+
+create_user-config.jam() {
+	local user_config_jam="${BUILD_DIR}"/user-config.jam
+	if [[ -s ${user_config_jam} ]]; then
+		einfo "${user_config_jam} already exists, skipping configuration"
+		return
+	else
+		einfo "Creating configuration in ${user_config_jam}"
+	fi
+
+	local compiler compiler_version compiler_executable="$(tc-getCXX)"
+	if [[ ${CHOST} == *-darwin* ]]; then
+		compiler="darwin"
+		compiler_version="$(gcc-fullversion)"
+	else
+		compiler="gcc"
+		compiler_version="$(gcc-version)"
+	fi
+
+	if use mpi; then
+		local mpi_configuration="using mpi ;"
+	fi
+
+	cat > "${user_config_jam}" <<- __EOF__ || die
+		using ${compiler} : ${compiler_version} : ${compiler_executable} : <cflags>"${CFLAGS}" <cxxflags>"${CXXFLAGS}" <linkflags>"${LDFLAGS}" ;
+		${mpi_configuration}
+	__EOF__
+
+	if python_bindings_needed; then
+		append_to_user_config() {
+			local py_config
+			if tc-is-cross-compiler; then
+				py_config="using python : ${EPYTHON#python} : : ${ESYSROOT}/usr/include/${EPYTHON} : ${ESYSROOT}/usr/$(get_libdir) ;"
+			else
+				py_config="using python : ${EPYTHON#python} : ${PYTHON} : $(python_get_includedir) ;"
+			fi
+			echo "${py_config}" >> "${user_config_jam}" || die
+		}
+		python_foreach_impl append_to_user_config
+	fi
+
+	if python_bindings_needed && use numpy; then
+		einfo "Enabling support for NumPy extensions in Boost.Python"
+	else
+		einfo "Disabling support for NumPy extensions in Boost.Python"
+
+		# Boost.Build does not allow for disabling of numpy
+		# extensions, thereby leading to automagic numpy
+		# https://github.com/boostorg/python/issues/111#issuecomment-280447482
+		sed \
+			-e 's/\[ unless \[ python\.numpy \] : <build>no \]/<build>no/g' \
+			-i "${BUILD_DIR}"/libs/python/build/Jamfile || die
+	fi
+}
+
+pkg_setup() {
+	# Bail out on unsupported build configuration, bug #456792
+	if [[ -f "${EROOT}"/etc/site-config.jam ]]; then
+		if ! grep -q 'gentoo\(debug\|release\)' "${EROOT}"/etc/site-config.jam; then
+			eerror "You are using custom ${EROOT}/etc/site-config.jam without defined gentoorelease/gentoodebug targets."
+			eerror "Boost can not be built in such configuration."
+			eerror "Please, either remove this file or add targets from ${EROOT}/usr/share/boost-build/site-config.jam to it."
+			die "Unsupported target in ${EROOT}/etc/site-config.jam"
+		fi
+	fi
+}
+
+src_prepare() {
+	default
+	multilib_copy_sources
+}
+
+ejam() {
+	create_user-config.jam
+
+	local b2_opts=( "--user-config=${BUILD_DIR}/user-config.jam" )
+	if python_bindings_needed; then
+		append_to_b2_opts() {
+			b2_opts+=( python="${EPYTHON#python}" )
+		}
+		python_foreach_impl append_to_b2_opts
+	else
+		b2_opts+=( --without-python )
+	fi
+	b2_opts+=( "$@" )
+
+	echo b2 "${b2_opts[@]}" >&2
+	b2 "${b2_opts[@]}"
+}
+
+src_configure() {
+	# Workaround for too many parallel processes requested, bug #506064
+	[[ "$(makeopts_jobs)" -gt 64 ]] && MAKEOPTS="${MAKEOPTS} -j64"
+
+	OPTIONS=(
+		$(usex debug gentoodebug gentoorelease)
+		"-j$(makeopts_jobs)"
+		-q
+		-d+2
+		pch=off
+		$(usex icu "-sICU_PATH=${ESYSROOT}/usr" '--disable-icu boost.locale.icu=off')
+		$(usex mpi '' '--without-mpi')
+		$(usex nls '' '--without-locale')
+		$(usex context '' '--without-context --without-coroutine --without-fiber')
+		$(usex threads '' '--without-thread')
+		--without-stacktrace
+		--boost-build="${BROOT}"/usr/share/boost-build
+		--prefix="${ED}/usr"
+		--layout=system
+		# CMake has issues working with multiple python impls,
+		# disable cmake config generation for the time being
+		# https://github.com/boostorg/python/issues/262#issuecomment-483069294
+		--no-cmake-config
+		# building with threading=single is currently not possible
+		# https://svn.boost.org/trac/boost/ticket/7105
+		threading=multi
+		link=$(usex static-libs shared,static shared)
+		# this seems to be the only way to disable compression algorithms
+		# https://www.boost.org/doc/libs/1_70_0/libs/iostreams/doc/installation.html#boost-build
+		-sNO_BZIP2=$(usex bzip2 0 1)
+		-sNO_LZMA=$(usex lzma 0 1)
+		-sNO_ZLIB=$(usex zlib 0 1)
+		-sNO_ZSTD=$(usex zstd 0 1)
+	)
+
+	if [[ ${CHOST} == *-darwin* ]]; then
+		# We need to add the prefix, and in two cases this exceeds, so prepare
+		# for the largest possible space allocation.
+		append-ldflags -Wl,-headerpad_max_install_names
+	fi
+
+	# Use C++14 globally as of 1.62
+	append-cxxflags -std=c++14
+}
+
+multilib_src_compile() {
+	ejam "${OPTIONS[@]}" || die
+
+	if tools_needed; then
+		pushd tools >/dev/null || die
+		ejam \
+			"${OPTIONS[@]}" \
+			|| die "Building of Boost tools failed"
+		popd >/dev/null || die
+	fi
+}
+
+multilib_src_install_all() {
+	if ! use numpy; then
+		rm -r "${ED}"/usr/include/boost/python/numpy* || die
+	fi
+
+	if use python; then
+		if use mpi; then
+			move_mpi_py_into_sitedir() {
+				local pyver="${EPYTHON#python}"
+				python_moduleinto boost
+				python_domodule "${ED}"/usr/$(get_libdir)/mpi${pyver/./}.so
+				rm "${ED}"/usr/$(get_libdir)/mpi${pyver/./}* || die
+				dosym mpi${pyver/./}.so $(python_get_sitedir)/boost/mpi.so
+
+				# create a proper python package
+				touch "${D}"/$(python_get_sitedir)/boost/__init__.py || die
+				python_optimize
+			}
+			python_foreach_impl move_mpi_py_into_sitedir
+		else
+			rm -r "${ED}"/usr/include/boost/mpi/python* || die
+		fi
+	else
+		rm -r "${ED}"/usr/include/boost/{python*,mpi/python*,parameter/aux_/python,parameter/python*} || die
+	fi
+
+	if ! use nls; then
+		rm -r "${ED}"/usr/include/boost/locale || die
+	fi
+
+	if ! use context; then
+		rm -r "${ED}"/usr/include/boost/context || die
+		rm -r "${ED}"/usr/include/boost/coroutine{,2} || die
+		rm "${ED}"/usr/include/boost/asio/spawn.hpp || die
+	fi
+
+	if use doc; then
+		# find extraneous files that shouldn't be installed
+		# as part of the documentation and remove them.
+		find libs/*/* \( -iname 'test' -o -iname 'src' \) -exec rm -rf '{}' + || die
+		find doc \( -name 'Jamfile.v2' -o -name 'build' -o -name '*.manifest' \) -exec rm -rf '{}' + || die
+		find tools \( -name 'Jamfile.v2' -o -name 'src' -o -name '*.cpp' -o -name '*.hpp' \) -exec rm -rf '{}' + || die
+
+		docinto html
+		dodoc *.{htm,html,png,css}
+		dodoc -r doc libs more tools
+
+		# To avoid broken links
+		dodoc LICENSE_1_0.txt
+
+		dosym ../../../../include/boost /usr/share/doc/${PF}/html/boost
+	fi
+}
+
+multilib_src_install() {
+	ejam \
+		"${OPTIONS[@]}" \
+		--includedir="${ED}/usr/include" \
+		--libdir="${ED}/usr/$(get_libdir)" \
+		install || die "Installation of Boost libraries failed"
+
+	pushd "${ED}/usr/$(get_libdir)" >/dev/null || die
+
+	local ext=$(get_libname)
+	if use threads; then
+		local f
+		for f in *${ext}; do
+			dosym ${f} /usr/$(get_libdir)/${f/${ext}/-mt${ext}}
+		done
+	fi
+
+	popd >/dev/null || die
+
+	if tools_needed; then
+		dobin dist/bin/*
+
+		insinto /usr/share
+		doins -r dist/share/boostbook
+	fi
+
+	# boost's build system truely sucks for not having a destdir.  Because for
+	# this reason we are forced to build with a prefix that includes the
+	# DESTROOT, dynamic libraries on Darwin end messed up, referencing the
+	# DESTROOT instread of the actual EPREFIX.  There is no way out of here
+	# but to do it the dirty way of manually setting the right install_names.
+	if [[ ${CHOST} == *-darwin* ]]; then
+		einfo "Working around completely broken build-system(tm)"
+		local d
+		for d in "${ED}"/usr/lib/*.dylib; do
+			if [[ -f ${d} ]]; then
+				# fix the "soname"
+				ebegin "  correcting install_name of ${d#${ED}}"
+				install_name_tool -id "/${d#${D}}" "${d}"
+				eend $?
+				# fix references to other libs
+				refs=$(otool -XL "${d}" | \
+					sed -e '1d' -e 's/^\t//' | \
+					grep "^libboost_" | \
+					cut -f1 -d' ')
+				local r
+				for r in ${refs}; do
+					ebegin "    correcting reference to ${r}"
+					install_name_tool -change \
+						"${r}" \
+						"${EPREFIX}/usr/lib/${r}" \
+						"${d}"
+					eend $?
+				done
+			fi
+		done
+	fi
+}
+
+pkg_preinst() {
+	# Yai for having symlinks that are nigh-impossible to remove without
+	# resorting to dirty hacks like these. Removes lingering symlinks
+	# from the slotted versions.
+	local symlink
+	for symlink in "${EROOT}"/usr/include/boost "${EROOT}"/usr/share/boostbook; do
+		if [[ -L ${symlink} ]]; then
+			rm -f "${symlink}" || die
+		fi
+	done
+
+	# some ancient installs still have boost cruft lying around
+	# for unknown reasons, causing havoc for reverse dependencies
+	# Bug: 607734
+	rm -rf "${EROOT}"/usr/include/boost-1_[3-5]? || die
+}
+
+pkg_postinst() {
+	elog "Boost.Regex is *extremely* ABI sensitive. If you get errors such as"
+	elog
+	elog "  undefined reference to \`boost::re_detail_$(ver_cut 1)0$(ver_cut 2)00::cpp_regex_traits_implementation"
+	elog "    <char>::transform_primary[abi:cxx11](char const*, char const*) const'"
+	elog
+	elog "Then you need to recompile Boost and all its reverse dependencies"
+	elog "using the same toolchain. In general, *every* change of the C++ toolchain"
+	elog "requires a complete rebuild of the boost-dependent ecosystem."
+	elog
+	elog "See for instance https://bugs.gentoo.org/638138"
+}

diff --git a/dev-libs/boost/files/boost-1.72.0-boost-mpi-python.patch b/dev-libs/boost/files/boost-1.72.0-boost-mpi-python.patch
new file mode 100644
index 000000000..8fb164a62
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.72.0-boost-mpi-python.patch
@@ -0,0 +1,50 @@
+Tag Boost.MPI python impls properly to avoid name clash
+https://github.com/boostorg/mpi/issues/112
+
+--- a/boostcpp.jam
++++ b/boostcpp.jam
+@@ -185,7 +185,7 @@
+ 
+ rule tag ( name : type ? : property-set )
+ {
+-    if $(type) in STATIC_LIB SHARED_LIB IMPORT_LIB
++    if $(type) in STATIC_LIB SHARED_LIB IMPORT_LIB PYTHON_EXTENSION
+     {
+         local args = $(.format-name-args) ;
+         if $(layout) = versioned
+@@ -223,7 +223,7 @@
+ {
+     local result = $(name) ;
+ 
+-    if $(type) in STATIC_LIB SHARED_LIB IMPORT_LIB
++    if $(type) in STATIC_LIB SHARED_LIB IMPORT_LIB PYTHON_EXTENSION
+     {
+         # Add Python version suffix
+ 
+--- a/libs/mpi/build/Jamfile.v2
++++ b/libs/mpi/build/Jamfile.v2
+@@ -58,13 +58,13 @@
+ rule python-tag ( name : type ? : property-set )
+ {
+     local result = $(name) ;
+-    if $(type) in STATIC_LIB SHARED_LIB IMPORT_LIB
++    if $(type) in STATIC_LIB SHARED_LIB IMPORT_LIB PYTHON_EXTENSION
+     {
+         local version = [ $(property-set).get <python> ] ;
+         local lib-suffix = [ version-suffix $(version) ] ;
+         result = $(result)$(lib-suffix) ;
+     }
+-    if $(type) in STATIC_LIB SHARED_LIB IMPORT_LIB && $(PYTHON_ID)
++    if $(type) in STATIC_LIB SHARED_LIB IMPORT_LIB PYTHON_EXTENSION && $(PYTHON_ID)
+     {
+         result = $(result)-$(PYTHON_ID) ;
+     }
+@@ -168,6 +168,8 @@
+                 <link>shared:<define>BOOST_PYTHON_DYN_LINK=1
+                 <link>shared <runtime-link>shared
+                 <python-debugging>on:<define>BOOST_DEBUG_PYTHON
++                -<tag>@$(BOOST_JAMROOT_MODULE)%$(BOOST_JAMROOT_MODULE).tag
++                <tag>@$(__name__).python-tag
+               ;
+ 
+             mpi_python_libs = boost_mpi_python mpi ;

diff --git a/dev-libs/boost/files/boost-1.72.0-missing-serialization-split_member-include.patch b/dev-libs/boost/files/boost-1.72.0-missing-serialization-split_member-include.patch
new file mode 100644
index 000000000..0c9f72583
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.72.0-missing-serialization-split_member-include.patch
@@ -0,0 +1,29 @@
+Missing #include, as the split_member.hpp include is not
+part of the nvp.hpp interface, and hence cannot be relied
+upon to be included transitively.
+
+Confirmed on
+https://github.com/boostorg/serialization/commit/c32a663c9963385430abc563f9c85f94d8da43a9#r36528430
+
+Bug: https://bugs.gentoo.org/703294
+
+--- a/boost/bimap/detail/map_view_iterator.hpp
++++ b/boost/bimap/detail/map_view_iterator.hpp
+@@ -22,6 +22,7 @@
+ 
+ #ifndef BOOST_BIMAP_DISABLE_SERIALIZATION
+   #include <boost/serialization/nvp.hpp>
++  #include <boost/serialization/split_member.hpp>
+ #endif // BOOST_BIMAP_DISABLE_SERIALIZATION
+ 
+ #include <boost/iterator/detail/enable_if.hpp>
+--- a/boost/bimap/detail/set_view_iterator.hpp
++++ b/boost/bimap/detail/set_view_iterator.hpp
+@@ -22,6 +22,7 @@
+ 
+ #ifndef BOOST_BIMAP_DISABLE_SERIALIZATION 
+   #include <boost/serialization/nvp.hpp>
++  #include <boost/serialization/split_member.hpp>
+ #endif // BOOST_BIMAP_DISABLE_SERIALIZATION
+ 
+ #include <boost/iterator/detail/enable_if.hpp>

diff --git a/dev-libs/boost/files/boost-1.72.0-revert-cease-dependence-on-range.patch b/dev-libs/boost/files/boost-1.72.0-revert-cease-dependence-on-range.patch
new file mode 100644
index 000000000..a6002074a
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.72.0-revert-cease-dependence-on-range.patch
@@ -0,0 +1,49 @@
+From 436e1dbe6fcd31523d261d18ad011392f1d6fbbc Mon Sep 17 00:00:00 2001
+From: Oliver Kowalke <oliver.kowalke@gmail.com>
+Date: Sun, 1 Dec 2019 20:40:28 +0100
+Subject: [PATCH] Revert "Cease dependence on Range"
+
+This reverts commit 0c556bb59241e682bbcd3f572815149c5a9b17db.
+
+see #44 (One test fails to compile after boostorg/coroutine submodule updated)
+---
+ boost/coroutine/asymmetric_coroutine.hpp | 12 +++---------
+ 1 file changed, 3 insertions(+), 9 deletions(-)
+
+diff --git a/boost/coroutine/asymmetric_coroutine.hpp b/boost/coroutine/asymmetric_coroutine.hpp
+index ea96981..640896f 100644
+--- a/boost/coroutine/asymmetric_coroutine.hpp
++++ b/boost/coroutine/asymmetric_coroutine.hpp
+@@ -14,6 +14,7 @@
+ #include <boost/assert.hpp>
+ #include <boost/config.hpp>
+ #include <boost/move/move.hpp>
++#include <boost/range.hpp>
+ #include <boost/throw_exception.hpp>
+ #include <boost/utility/explicit_operator_bool.hpp>
+ 
+@@ -2354,19 +2355,12 @@ end( push_coroutine< R > & c)
+ 
+ }
+ 
+-// forward declaration of Boost.Range traits to break dependency on it
+-template<typename C, typename Enabler>
+-struct range_mutable_iterator;
+-
+-template<typename C, typename Enabler>
+-struct range_const_iterator;
+-
+ template< typename Arg >
+-struct range_mutable_iterator< coroutines::push_coroutine< Arg >, void >
++struct range_mutable_iterator< coroutines::push_coroutine< Arg > >
+ { typedef typename coroutines::push_coroutine< Arg >::iterator type; };
+ 
+ template< typename R >
+-struct range_mutable_iterator< coroutines::pull_coroutine< R >, void >
++struct range_mutable_iterator< coroutines::pull_coroutine< R > >
+ { typedef typename coroutines::pull_coroutine< R >::iterator type; };
+ 
+ }
+-- 
+2.24.1
+

diff --git a/dev-libs/boost/metadata.xml b/dev-libs/boost/metadata.xml
new file mode 100644
index 000000000..4f031402a
--- /dev/null
+++ b/dev-libs/boost/metadata.xml
@@ -0,0 +1,21 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+	<maintainer type="project">
+		<email>sci@gentoo.org</email>
+		<description>Gentoo Science Project</description>
+	</maintainer>
+	<use>
+		<flag name="context">Build and install the Boost.Context (and Boost.Fiber) library and all other Boost libraries that depend on it</flag>
+		<flag name="debug">Build and install only the debug version of the Boost libraries. Only enable this flag if you're developing against boost.</flag>
+		<flag name="doc">Install the full API documentation documentation. This takes over 200MB of extra disk space.</flag>
+		<flag name="nls">Build libboost_locale. This library requires compatible C library interfaces, which might not be provided by uClibc or other embedded libraries.</flag>
+		<flag name="numpy">Optionally build NumPy extensions when Boost.Python is enabled</flag>
+		<flag name="threads">Build multi-thread-compatible libraries instead of single-threaded only.</flag>
+		<flag name="tools">Build and install the boost tools (bcp, quickbook, inspect, wave)</flag>
+	</use>
+	<upstream>
+		<remote-id type="cpe">cpe:/a:boost:boost</remote-id>
+		<remote-id type="sourceforge">boost</remote-id>
+	</upstream>
+</pkgmetadata>


^ permalink raw reply related	[flat|nested] 3+ messages in thread
* [gentoo-commits] proj/sci:master commit in: dev-libs/boost/, dev-libs/boost/files/
@ 2015-04-18 16:27 Christoph Junghans
  0 siblings, 0 replies; 3+ messages in thread
From: Christoph Junghans @ 2015-04-18 16:27 UTC (permalink / raw
  To: gentoo-commits

commit:     0e0146796c5d2ad293977ce9fab2642524b8ff37
Author:     Christoph Junghans <ottxor <AT> gentoo <DOT> org>
AuthorDate: Sat Apr 18 16:19:07 2015 +0000
Commit:     Christoph Junghans <ottxor <AT> gentoo <DOT> org>
CommitDate: Sat Apr 18 16:19:07 2015 +0000
URL:        https://gitweb.gentoo.org/proj/sci.git/commit/?id=0e014679

Revert "In CVS" to multilib-mpi version back

This reverts commit f42e050833880c400b1fdd63505066dee8dcf4df.

 dev-libs/boost/ChangeLog                           |  24 ++
 dev-libs/boost/boost-1.56.0-r2.ebuild              | 398 +++++++++++++++++++++
 .../files/boost-1.48.0-disable_icu_rpath.patch     |  29 ++
 .../boost-1.48.0-disable_libboost_python3.patch    |  62 ++++
 .../boost-1.48.0-no_strict_aliasing_python2.patch  |  23 ++
 .../boost/files/boost-1.48.0-python_linking.patch  |  24 ++
 .../boost-1.51.0-respect_python-buildid.patch      |  69 ++++
 ...ost-1.51.0-support_dots_in_python-buildid.patch |  22 ++
 dev-libs/boost/files/boost-1.52.0-threads.patch    |  63 ++++
 .../boost/files/boost-1.55.0-context-x32.patch     |  42 +++
 .../files/boost-1.55.0-tools-c98-compat.patch      |  17 +
 .../files/boost-1.56.0-build-auto_index-tool.patch |  13 +
 dev-libs/boost/metadata.xml                        |  38 ++
 13 files changed, 824 insertions(+)

diff --git a/dev-libs/boost/ChangeLog b/dev-libs/boost/ChangeLog
new file mode 100644
index 0000000..d0283a4
--- /dev/null
+++ b/dev-libs/boost/ChangeLog
@@ -0,0 +1,24 @@
+# ChangeLog for dev-libs/boost
+# Copyright 1999-2015 Gentoo Foundation; Distributed under the GPL v2
+# $Header: $
+
+  02 Apr 2015; Justin Lecher <jlec@gentoo.org> boost-1.56.0-r2.ebuild,
+  metadata.xml:
+  dev-libs/boost: Move to new CAT
+
+  19 Feb 2015; Christoph Junghans <ottxor@gentoo.org> boost-1.56.0-r2.ebuild:
+  dropped sparc
+
+*boost-1.56.0-r2 (17 Feb 2015)
+
+  17 Feb 2015; Christoph Junghans <ottxor@gentoo.org> +boost-1.56.0-r2.ebuild,
+  +files/boost-1.48.0-disable_icu_rpath.patch,
+  +files/boost-1.48.0-disable_libboost_python3.patch,
+  +files/boost-1.48.0-no_strict_aliasing_python2.patch,
+  +files/boost-1.48.0-python_linking.patch,
+  +files/boost-1.51.0-respect_python-buildid.patch,
+  +files/boost-1.51.0-support_dots_in_python-buildid.patch,
+  +files/boost-1.52.0-threads.patch, +files/boost-1.55.0-context-x32.patch,
+  +files/boost-1.55.0-tools-c98-compat.patch,
+  +files/boost-1.56.0-build-auto_index-tool.patch, +metadata.xml:
+  added full multilib version

diff --git a/dev-libs/boost/boost-1.56.0-r2.ebuild b/dev-libs/boost/boost-1.56.0-r2.ebuild
new file mode 100644
index 0000000..e732f16
--- /dev/null
+++ b/dev-libs/boost/boost-1.56.0-r2.ebuild
@@ -0,0 +1,398 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: $
+
+EAPI="5"
+PYTHON_COMPAT=( python{2_7,3_3,3_4} )
+
+inherit eutils flag-o-matic multilib multiprocessing python-r1 toolchain-funcs versionator multilib-minimal
+
+MY_P="${PN}_$(replace_all_version_separators _)"
+MAJOR_V="$(get_version_component_range 1-2)"
+
+DESCRIPTION="Boost Libraries for C++"
+HOMEPAGE="http://www.boost.org/"
+SRC_URI="mirror://sourceforge/boost/${MY_P}.tar.bz2"
+
+LICENSE="Boost-1.0"
+SLOT="0/${PV}" # ${PV} instead ${MAJOR_V} due to bug 486122
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh ~x86 ~ppc-aix ~amd64-fbsd ~x86-fbsd ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x86-solaris ~x86-winnt"
+
+IUSE="context debug doc icu +nls mpi python static-libs +threads tools"
+
+RDEPEND="abi_x86_32? ( !app-emulation/emul-linux-x86-cpplibs[-abi_x86_32(-)] )
+	icu? ( >=dev-libs/icu-3.6:=[${MULTILIB_USEDEP}] )
+	!icu? ( virtual/libiconv[${MULTILIB_USEDEP}] )
+	mpi? ( >=virtual/mpi-2.0-r4[${MULTILIB_USEDEP},cxx,threads] )
+	python? ( ${PYTHON_DEPS} )
+	app-arch/bzip2[${MULTILIB_USEDEP}]
+	sys-libs/zlib[${MULTILIB_USEDEP}]
+	!app-eselect/eselect-boost"
+DEPEND="${RDEPEND}
+	=dev-util/boost-build-${MAJOR_V}*"
+REQUIRED_USE="
+	mpi? ( threads )
+	python? ( ${PYTHON_REQUIRED_USE} )"
+
+S="${WORKDIR}/${MY_P}"
+
+# the tests will never fail because these are not intended as sanity
+# tests at all. They are more a way for upstream to check their own code
+# on new compilers. Since they would either be completely unreliable
+# (failing for no good reason) or completely useless (never failing)
+# there is no point in having them in the ebuild to begin with.
+RESTRICT="test"
+
+python_bindings_needed() {
+	multilib_is_native_abi && use python
+}
+
+tools_needed() {
+	multilib_is_native_abi && use tools
+}
+
+create_user-config.jam() {
+	local compiler compiler_version compiler_executable
+
+	if [[ ${CHOST} == *-darwin* ]]; then
+		compiler="darwin"
+		compiler_version="$(gcc-fullversion)"
+		compiler_executable="$(tc-getCXX)"
+	else
+		compiler="gcc"
+		compiler_version="$(gcc-version)"
+		compiler_executable="$(tc-getCXX)"
+	fi
+	local mpi_configuration python_configuration
+
+	if use mpi; then
+		mpi_configuration="using mpi ;"
+	fi
+
+	if python_bindings_needed; then
+		if tc-is-cross-compiler; then
+			python_configuration="using python : ${EPYTHON#python} : : ${SYSROOT:-${EROOT}}/usr/include/${EPYTHON} : ${SYSROOT:-${EROOT}}/usr/$(get_libdir) ;"
+		else
+			python_configuration="using python : : ${PYTHON} ;"
+		fi
+	fi
+
+	cat > "${BOOST_ROOT}/user-config.jam" << __EOF__
+using ${compiler} : ${compiler_version} : ${compiler_executable} : <cflags>"${CFLAGS}" <cxxflags>"${CXXFLAGS}" <linkflags>"${LDFLAGS}" ;
+${mpi_configuration}
+${python_configuration}
+__EOF__
+}
+
+pkg_setup() {
+	# Bail out on unsupported build configuration, bug #456792
+	if [[ -f "${EROOT}etc/site-config.jam" ]]; then
+		grep -q gentoorelease "${EROOT}etc/site-config.jam" && grep -q gentoodebug "${EROOT}etc/site-config.jam" ||
+		(
+			eerror "You are using custom ${EROOT}etc/site-config.jam without defined gentoorelease/gentoodebug targets."
+			eerror "Boost can not be built in such configuration."
+			eerror "Please, either remove this file or add targets from ${EROOT}usr/share/boost-build/site-config.jam to it."
+			die
+		)
+	fi
+}
+
+src_prepare() {
+	epatch \
+		"${FILESDIR}/${PN}-1.51.0-respect_python-buildid.patch" \
+		"${FILESDIR}/${PN}-1.51.0-support_dots_in_python-buildid.patch" \
+		"${FILESDIR}/${PN}-1.48.0-no_strict_aliasing_python2.patch" \
+		"${FILESDIR}/${PN}-1.48.0-disable_libboost_python3.patch" \
+		"${FILESDIR}/${PN}-1.48.0-python_linking.patch" \
+		"${FILESDIR}/${PN}-1.48.0-disable_icu_rpath.patch" \
+		"${FILESDIR}/${PN}-1.55.0-context-x32.patch" \
+		"${FILESDIR}/${PN}-1.55.0-tools-c98-compat.patch" \
+		"${FILESDIR}/${PN}-1.52.0-threads.patch" \
+		"${FILESDIR}/${PN}-1.56.0-build-auto_index-tool.patch"
+
+	# Do not try to build missing 'wave' tool, bug #522682
+	# Upstream bugreport - https://svn.boost.org/trac/boost/ticket/10507
+	sed -i -e 's:wave/build//wave::' tools/Jamfile.v2 || die
+
+	epatch_user
+
+	multilib_copy_sources
+}
+
+ejam() {
+	local b2_opts="--user-config=${BOOST_ROOT}/user-config.jam $@"
+	echo b2 ${b2_opts}
+	b2 ${b2_opts}
+}
+
+src_configure() {
+	# Workaround for too many parallel processes requested, bug #506064
+	[ "$(makeopts_jobs)" -gt 64 ] && MAKEOPTS="${MAKEOPTS} -j64"
+
+	OPTIONS="$(usex debug gentoodebug gentoorelease) -j$(makeopts_jobs) -q -d+2"
+
+	if [[ ${CHOST} == *-darwin* ]]; then
+		# We need to add the prefix, and in two cases this exceeds, so prepare
+		# for the largest possible space allocation.
+		append-ldflags -Wl,-headerpad_max_install_names
+	elif [[ ${CHOST} == *-winnt* ]]; then
+		compiler=parity
+		if [[ $($(tc-getCXX) -v) == *trunk* ]]; then
+			compilerVersion=trunk
+		else
+			compilerVersion=$($(tc-getCXX) -v | sed '1q' \
+				| sed -e 's,\([a-z]*\) \([0-9]\.[0-9]\.[0-9][^ \t]*\) .*,\2,')
+		fi
+		compilerExecutable=$(tc-getCXX)
+	fi
+
+	# bug 298489
+	if use ppc || use ppc64; then
+		[[ $(gcc-version) > 4.3 ]] && append-flags -mno-altivec
+	fi
+
+	# Do _not_ use C++11 yet, make sure to force GNU C++ 98 standard.
+	append-cxxflags -std=gnu++98
+
+	use icu && OPTIONS+=" -sICU_PATH=${EPREFIX}/usr"
+	use icu || OPTIONS+=" --disable-icu boost.locale.icu=off"
+	use mpi || OPTIONS+=" --without-mpi"
+	use nls || OPTIONS+=" --without-locale"
+	use context || OPTIONS+=" --without-context --without-coroutine"
+
+	OPTIONS+=" pch=off"
+	OPTIONS+=" --boost-build=${EPREFIX}/usr/share/boost-build --prefix=\"${ED}usr\""
+	OPTIONS+=" --layout=system"
+	OPTIONS+=" threading=$(usex threads multi single) link=$(usex static-libs shared,static shared)"
+
+	[[ ${CHOST} == *-winnt* ]] && OPTIONS+=" -sNO_BZIP2=1"
+}
+
+multilib_src_compile() {
+	local -x BOOST_ROOT="${BUILD_DIR}"
+	PYTHON_DIRS=""
+	MPI_PYTHON_MODULE=""
+
+	building() {
+		create_user-config.jam
+
+		local PYTHON_OPTIONS
+		if python_bindings_needed; then
+			PYTHON_OPTIONS=" --python-buildid=${EPYTHON#python}"
+		else
+			PYTHON_OPTIONS=" --without-python"
+		fi
+
+		ejam \
+			${OPTIONS} \
+			${PYTHON_OPTIONS} \
+			|| die "Building of Boost libraries failed"
+
+		if python_bindings_needed; then
+			if [[ -z "${PYTHON_DIRS}" ]]; then
+				PYTHON_DIRS="$(find bin.v2/libs -name python | sort)"
+			else
+				if [[ "${PYTHON_DIRS}" != "$(find bin.v2/libs -name python | sort)" ]]; then
+					die "Inconsistent structure of build directories"
+				fi
+			fi
+
+			local dir
+			for dir in ${PYTHON_DIRS}; do
+				mv ${dir} ${dir}-${EPYTHON} \
+					|| die "Renaming of '${dir}' to '${dir}-${EPYTHON}' failed"
+			done
+
+			if use mpi; then
+				if [[ -z "${MPI_PYTHON_MODULE}" ]]; then
+					MPI_PYTHON_MODULE="$(find bin.v2/libs/mpi/build/*/gentoo* -name mpi.so)"
+					if [[ "$(echo "${MPI_PYTHON_MODULE}" | wc -l)" -ne 1 ]]; then
+						die "Multiple mpi.so files found"
+					fi
+				else
+					if [[ "${MPI_PYTHON_MODULE}" != "$(find bin.v2/libs/mpi/build/*/gentoo* -name mpi.so)" ]]; then
+						die "Inconsistent structure of build directories"
+					fi
+				fi
+
+				mv stage/lib/mpi.so stage/lib/mpi.so-${EPYTHON} \
+					|| die "Renaming of 'stage/lib/mpi.so' to 'stage/lib/mpi.so-${EPYTHON}' failed"
+			fi
+		fi
+	}
+	if python_bindings_needed; then
+		python_foreach_impl building
+	else
+		building
+	fi
+
+	if tools_needed; then
+		pushd tools > /dev/null || die
+
+		ejam \
+			${OPTIONS} \
+			${PYTHON_OPTIONS} \
+			|| die "Building of Boost tools failed"
+		popd > /dev/null || die
+	fi
+}
+
+multilib_src_install_all() {
+	if ! use python; then
+		rm -r "${ED}"/usr/include/boost/python* || die
+	fi
+
+	if ! use nls; then
+		rm -r "${ED}"/usr/include/boost/locale || die
+	fi
+
+	if ! use context; then
+		rm -r "${ED}"/usr/include/boost/context || die
+		rm -r "${ED}"/usr/include/boost/coroutine || die
+	fi
+
+	if use doc; then
+		find libs/*/* -iname "test" -or -iname "src" | xargs rm -rf
+		dohtml \
+			-A pdf,txt,cpp,hpp \
+			*.{htm,html,png,css} \
+			-r doc
+		dohtml -A pdf,txt -r tools
+		insinto /usr/share/doc/${PF}/html
+		doins -r libs
+		doins -r more
+
+		# To avoid broken links
+		insinto /usr/share/doc/${PF}/html
+		doins LICENSE_1_0.txt
+
+		dosym /usr/include/boost /usr/share/doc/${PF}/html/boost
+	fi
+}
+
+multilib_src_install() {
+	local -x BOOST_ROOT="${BUILD_DIR}"
+	installation() {
+		create_user-config.jam
+
+		local PYTHON_OPTIONS
+		if python_bindings_needed; then
+			local dir
+			for dir in ${PYTHON_DIRS}; do
+				cp -pr ${dir}-${EPYTHON} ${dir} \
+					|| die "Copying of '${dir}-${EPYTHON}' to '${dir}' failed"
+			done
+
+			if use mpi; then
+				cp -p stage/lib/mpi.so-${EPYTHON} "${MPI_PYTHON_MODULE}" \
+					|| die "Copying of 'stage/lib/mpi.so-${EPYTHON}' to '${MPI_PYTHON_MODULE}' failed"
+				cp -p stage/lib/mpi.so-${EPYTHON} stage/lib/mpi.so \
+					|| die "Copying of 'stage/lib/mpi.so-${EPYTHON}' to 'stage/lib/mpi.so' failed"
+			fi
+			PYTHON_OPTIONS=" --python-buildid=${EPYTHON#python}"
+		else
+			PYTHON_OPTIONS=" --without-python"
+		fi
+
+		ejam \
+			${OPTIONS} \
+			${PYTHON_OPTIONS} \
+			--includedir="${ED}usr/include" \
+			--libdir="${ED}usr/$(get_libdir)" \
+			install || die "Installation of Boost libraries failed"
+
+		if python_bindings_needed; then
+			rm -r ${PYTHON_DIRS} || die
+
+			# Move mpi.so Python module to Python site-packages directory.
+			# https://svn.boost.org/trac/boost/ticket/2838
+			if use mpi; then
+				local moddir=$(python_get_sitedir)/boost
+				# moddir already includes eprefix
+				mkdir -p "${D}${moddir}" || die
+				mv "${ED}usr/$(get_libdir)/mpi.so" "${D}${moddir}" || die
+				cat << EOF > "${D}${moddir}/__init__.py" || die
+import sys
+if sys.platform.startswith('linux'):
+	import DLFCN
+	flags = sys.getdlopenflags()
+	sys.setdlopenflags(DLFCN.RTLD_NOW | DLFCN.RTLD_GLOBAL)
+	from . import mpi
+	sys.setdlopenflags(flags)
+	del DLFCN, flags
+else:
+	from . import mpi
+del sys
+EOF
+			fi
+
+			python_optimize
+		fi
+	}
+	if python_bindings_needed; then
+		python_foreach_impl installation
+	else
+		installation
+	fi
+
+	pushd "${ED}usr/$(get_libdir)" > /dev/null || die
+
+	local ext=$(get_libname)
+	if use threads; then
+		local f
+		for f in *${ext}; do
+			dosym ${f} /usr/$(get_libdir)/${f/${ext}/-mt${ext}}
+		done
+	fi
+
+	popd > /dev/null || die
+
+	if tools_needed; then
+		dobin dist/bin/*
+
+		insinto /usr/share
+		doins -r dist/share/boostbook
+	fi
+
+	# boost's build system truely sucks for not having a destdir.  Because for
+	# this reason we are forced to build with a prefix that includes the
+	# DESTROOT, dynamic libraries on Darwin end messed up, referencing the
+	# DESTROOT instread of the actual EPREFIX.  There is no way out of here
+	# but to do it the dirty way of manually setting the right install_names.
+	if [[ ${CHOST} == *-darwin* ]]; then
+		einfo "Working around completely broken build-system(tm)"
+		local d
+		for d in "${ED}"usr/lib/*.dylib; do
+			if [[ -f ${d} ]]; then
+				# fix the "soname"
+				ebegin "  correcting install_name of ${d#${ED}}"
+				install_name_tool -id "/${d#${D}}" "${d}"
+				eend $?
+				# fix references to other libs
+				refs=$(otool -XL "${d}" | \
+					sed -e '1d' -e 's/^\t//' | \
+					grep "^libboost_" | \
+					cut -f1 -d' ')
+				local r
+				for r in ${refs}; do
+					ebegin "    correcting reference to ${r}"
+					install_name_tool -change \
+						"${r}" \
+						"${EPREFIX}/usr/lib/${r}" \
+						"${d}"
+					eend $?
+				done
+			fi
+		done
+	fi
+}
+
+pkg_preinst() {
+	# Yai for having symlinks that are nigh-impossible to remove without
+	# resorting to dirty hacks like these. Removes lingering symlinks
+	# from the slotted versions.
+	local symlink
+	for symlink in "${EROOT}usr/include/boost" "${EROOT}usr/share/boostbook"; do
+		[[ -L ${symlink} ]] && rm -f "${symlink}"
+	done
+}

diff --git a/dev-libs/boost/files/boost-1.48.0-disable_icu_rpath.patch b/dev-libs/boost/files/boost-1.48.0-disable_icu_rpath.patch
new file mode 100644
index 0000000..a902d61
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.48.0-disable_icu_rpath.patch
@@ -0,0 +1,29 @@
+--- libs/locale/build/Jamfile.v2
++++ libs/locale/build/Jamfile.v2
+@@ -58,8 +58,8 @@
+ 
+ if $(ICU_LINK)
+ {
+-    ICU_OPTS = <include>$(ICU_PATH)/include <linkflags>$(ICU_LINK) <dll-path>$(ICU_PATH)/bin <runtime-link>shared ;
+-    ICU64_OPTS = <include>$(ICU_PATH)/include <linkflags>$(ICU_LINK) <dll-path>$(ICU_PATH)/bin64 <runtime-link>shared ;
++    ICU_OPTS = <include>$(ICU_PATH)/include <linkflags>$(ICU_LINK) <runtime-link>shared ;
++    ICU64_OPTS = <include>$(ICU_PATH)/include <linkflags>$(ICU_LINK) <runtime-link>shared ;
+ }
+ else
+ {
+@@ -117,7 +117,6 @@
+       <library>icuuc/<link>shared/<runtime-link>shared 
+       <library>icudt/<link>shared/<runtime-link>shared 
+       <library>icuin/<link>shared/<runtime-link>shared
+-      <dll-path>$(ICU_PATH)/bin
+         <runtime-link>shared ;
+ 
+ 
+@@ -176,7 +175,6 @@
+       <library>icuuc_64/<link>shared/<runtime-link>shared 
+       <library>icudt_64/<link>shared/<runtime-link>shared 
+       <library>icuin_64/<link>shared/<runtime-link>shared
+-      <dll-path>$(ICU_PATH)/bin64
+         <runtime-link>shared ;
+  
+     

diff --git a/dev-libs/boost/files/boost-1.48.0-disable_libboost_python3.patch b/dev-libs/boost/files/boost-1.48.0-disable_libboost_python3.patch
new file mode 100644
index 0000000..c24a56c
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.48.0-disable_libboost_python3.patch
@@ -0,0 +1,62 @@
+--- libs/python/build/Jamfile.v2
++++ libs/python/build/Jamfile.v2
+@@ -39,23 +39,6 @@
+     PYTHON_ID = [ regex.replace $(python-id) "[*\\/:\"\']" "_" ] ;
+ }
+ 
+-
+-rule find-py3-version
+-{
+-    local versions = [ feature.values python ] ;
+-    local py3ver ;
+-    for local v in $(versions)
+-    {
+-        if $(v) >= 3.0
+-        {
+-            py3ver = $(v) ;
+-        }
+-    }
+-    return $(py3ver) ;
+-}
+-
+-py3-version = [ find-py3-version ] ;
+-
+ project boost/python
+   : source-location ../src
+   : requirements
+@@ -82,7 +65,7 @@
+ rule cond ( test ? : yes * : no * ) { if $(test) { return $(yes) ; } else { return $(no) ; } }
+ rule unless ( test ? : yes * : no * ) { if ! $(test) { return $(yes) ; } else { return $(no) ; } }
+ 
+-rule lib_boost_python ( is-py3 ? )
++rule lib_boost_python
+ {
+ 
+     local python_major_version = [ MATCH "^([^.]+)" : [ feature.values python ] ] ;
+@@ -91,7 +74,7 @@
+     {
+         python2 = true ;
+     }
+-    lib [ cond $(is-py3) : boost_python3 : boost_python ]
++    lib boost_python
+         : # sources
+         numeric.cpp
+         list.cpp
+@@ -148,7 +131,6 @@
+             <dependency>config-warning
+ 
+             <python-debugging>on:<define>BOOST_DEBUG_PYTHON
+-            [ cond $(is-py3) : <python>$(py3-version) ]
+         :   # default build
+             <link>shared
+         :   # usage requirements
+@@ -160,9 +142,3 @@
+ 
+ lib_boost_python ;
+ boost-install boost_python ;
+-
+-if $(py3-version)
+-{
+-    lib_boost_python yes ;
+-    boost-install boost_python3 ;
+-}

diff --git a/dev-libs/boost/files/boost-1.48.0-no_strict_aliasing_python2.patch b/dev-libs/boost/files/boost-1.48.0-no_strict_aliasing_python2.patch
new file mode 100644
index 0000000..89f8109
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.48.0-no_strict_aliasing_python2.patch
@@ -0,0 +1,23 @@
+--- libs/python/build/Jamfile.v2
++++ libs/python/build/Jamfile.v2
+@@ -85,6 +85,12 @@
+ rule lib_boost_python ( is-py3 ? )
+ {
+ 
++    local python_major_version = [ MATCH "^([^.]+)" : [ feature.values python ] ] ;
++    local python2 ;
++    if $(python_major_version) = 2
++    {
++        python2 = true ;
++    }
+     lib [ cond $(is-py3) : boost_python3 : boost_python ]
+         : # sources
+         numeric.cpp
+@@ -119,6 +125,7 @@
+         :   # requirements
+             <link>static:<define>BOOST_PYTHON_STATIC_LIB 
+             <define>BOOST_PYTHON_SOURCE
++            [ cond $(python2) : <cxxflags>-fno-strict-aliasing ]
+           
+             # On Windows, all code using Python has to link to the Python
+             # import library.

diff --git a/dev-libs/boost/files/boost-1.48.0-python_linking.patch b/dev-libs/boost/files/boost-1.48.0-python_linking.patch
new file mode 100644
index 0000000..e7f4e7c
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.48.0-python_linking.patch
@@ -0,0 +1,24 @@
+--- libs/python/build/Jamfile.v2
++++ libs/python/build/Jamfile.v2
+@@ -109,20 +109,7 @@
+             <link>static:<define>BOOST_PYTHON_STATIC_LIB 
+             <define>BOOST_PYTHON_SOURCE
+             [ cond $(python2) : <cxxflags>-fno-strict-aliasing ]
+-          
+-            # On Windows, all code using Python has to link to the Python
+-            # import library.
+-            #
+-            # On *nix we never link libboost_python to libpython.  When
+-            # extending Python, all Python symbols are provided by the
+-            # Python interpreter executable.  When embedding Python, the
+-            # client executable is expected to explicitly link to
+-            # /python//python (the target representing libpython) itself.
+-            #
+-            # python_for_extensions is a target defined by Boost.Build to
+-            # provide the Python include paths, and on Windows, the Python
+-            # import library, as usage requirements.
+-            [ cond [ python.configured ] : <library>/python//python_for_extensions ]
++            [ cond [ python.configured ] : <library>/python//python ]
+             
+             # we prevent building when there is no python available
+             # as it's not possible anyway, and to cause dependents to

diff --git a/dev-libs/boost/files/boost-1.51.0-respect_python-buildid.patch b/dev-libs/boost/files/boost-1.51.0-respect_python-buildid.patch
new file mode 100644
index 0000000..327429e
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.51.0-respect_python-buildid.patch
@@ -0,0 +1,69 @@
+https://svn.boost.org/trac/boost/ticket/6286
+
+--- boostcpp.jam
++++ boostcpp.jam
+@@ -99,13 +99,6 @@
+     BUILD_ID = [ regex.replace $(build-id) "[*\\/:.\"\' ]" _ ] ;
+ }
+ 
+-# Python build id (for Python libraries only).
+-python-id = [ option.get "python-buildid" ] ;
+-if $(python-id)
+-{
+-    PYTHON_ID = [ regex.replace $(python-id) [*\\/:.\"\'] _ ] ;
+-}
+-
+ 
+ ################################################################################
+ #
+--- libs/mpi/build/Jamfile.v2
++++ libs/mpi/build/Jamfile.v2
+@@ -8,6 +8,8 @@
+ #  Authors: Douglas Gregor
+ #           Andrew Lumsdaine
+ 
++import option ;
++import regex ;
+ import mpi ;
+ import indirect ;
+ import python ;
+@@ -24,6 +26,13 @@
+     <tag>@$(__name__).tag
+   ;
+ 
++# Python build id (for Python libraries only).
++python-id = [ option.get "python-buildid" ] ;
++if $(python-id)
++{
++    PYTHON_ID = [ regex.replace $(python-id) [*\\/:.\"\'] _ ] ;
++}
++
+ rule tag ( name : type ? : property-set )
+ {
+     local result = $(name) ;
+--- libs/python/build/Jamfile.v2
++++ libs/python/build/Jamfile.v2
+@@ -2,6 +2,8 @@
+ # Software License, Version 1.0. (See accompanying
+ # file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
+ 
++import option ;
++import regex ;
+ import os ;
+ import indirect ;
+ import modules ;
+@@ -30,6 +32,14 @@
+         ;
+ }
+ 
++# Python build id (for Python libraries only).
++python-id = [ option.get "python-buildid" ] ;
++if $(python-id)
++{
++    PYTHON_ID = [ regex.replace $(python-id) [*\\/:.\"\'] _ ] ;
++}
++
++
+ rule find-py3-version
+ {
+     local versions = [ feature.values python ] ;

diff --git a/dev-libs/boost/files/boost-1.51.0-support_dots_in_python-buildid.patch b/dev-libs/boost/files/boost-1.51.0-support_dots_in_python-buildid.patch
new file mode 100644
index 0000000..c8dc6e1
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.51.0-support_dots_in_python-buildid.patch
@@ -0,0 +1,22 @@
+--- libs/mpi/build/Jamfile.v2
++++ libs/mpi/build/Jamfile.v2
+@@ -30,7 +30,7 @@
+ python-id = [ option.get "python-buildid" ] ;
+ if $(python-id)
+ {
+-    PYTHON_ID = [ regex.replace $(python-id) [*\\/:.\"\'] _ ] ;
++    PYTHON_ID = [ regex.replace $(python-id) [*\\/:\"\'] _ ] ;
+ }
+ 
+ rule tag ( name : type ? : property-set )
+--- libs/python/build/Jamfile.v2
++++ libs/python/build/Jamfile.v2
+@@ -36,7 +36,7 @@
+ python-id = [ option.get "python-buildid" ] ;
+ if $(python-id)
+ {
+-    PYTHON_ID = [ regex.replace $(python-id) [*\\/:.\"\'] _ ] ;
++    PYTHON_ID = [ regex.replace $(python-id) [*\\/:\"\'] _ ] ;
+ }
+ 
+ 

diff --git a/dev-libs/boost/files/boost-1.52.0-threads.patch b/dev-libs/boost/files/boost-1.52.0-threads.patch
new file mode 100644
index 0000000..e078fc2
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.52.0-threads.patch
@@ -0,0 +1,63 @@
+Index: /trunk/boostcpp.jam
+===================================================================
+--- /trunk/boostcpp.jam	(revision 79301)
++++ /trunk/boostcpp.jam	(revision 81000)
+@@ -210,6 +210,44 @@
+ }
+ 
++rule filtered-target ( name : message + : sources + : requirements * )
++{
++    message $(name)-message : warning: $(message) ;
++    alias $(name) : $(sources) : $(requirements) ;
++    alias $(name) : $(name)-message ;
++
++    local p = [ project.current ] ;
++    $(p).mark-target-as-explicit $(name) ;
++    $(p).mark-target-as-explicit $(name)-message ;
++}
++
+ rule declare_install_and_stage_proper_targets ( libraries * : headers * )
+ {
++    for local l in $(libraries)
++    {
++        if $(l) = locale
++        {
++            filtered-target $(l)-for-install :
++                Skipping Boost.Locale library with threading=single. :
++                libs/$(l)/build : <threading>multi ;
++        }
++        else if $(l) = wave
++        {
++            filtered-target $(l)-for-install :
++                Skipping Boost.Wave library with threading=single. :
++                libs/$(l)/build : <threading>multi ;
++        }
++        else if $(l) = thread
++        {
++            filtered-target $(l)-for-install :
++                Skipping Boost.Thread library with threading=single. :
++                libs/$(l)/build : <threading>multi ;
++        }
++        else
++        {
++            alias $(l)-for-install : libs/$(l)/build ; 
++        }
++    }
++    local library-targets = $(libraries)-for-install ;
++
+     install-requirements = <install-source-root>$(BOOST_ROOT)/boost ;
+ 
+@@ -239,5 +277,5 @@
+         : $(install-requirements) <install-no-version-symlinks>on
+         :
+-        : libs/$(libraries)/build
++        : $(libraries)-for-install
+         : $(headers)
+         ;
+@@ -246,5 +284,5 @@
+     # Install just library.
+     install stage-proper
+-        : libs/$(libraries)/build
++        : $(libraries)-for-install
+         : <location>$(stage-locate)/lib
+           <install-dependencies>on <install-type>LIB

diff --git a/dev-libs/boost/files/boost-1.55.0-context-x32.patch b/dev-libs/boost/files/boost-1.55.0-context-x32.patch
new file mode 100644
index 0000000..5bf7406
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.55.0-context-x32.patch
@@ -0,0 +1,42 @@
+https://svn.boost.org/trac/boost/ticket/9445
+
+hack to fix x32 builds
+
+--- a/libs/context/src/asm/jump_i386_sysv_elf_gas.S
++++ b/libs/context/src/asm/jump_i386_sysv_elf_gas.S
+@@ -31,6 +31,10 @@
+  *                                                                  *
+  * *****************************************************************/
+ 
++#ifdef __x86_64__
++#include "jump_x86_64_sysv_elf_gas.S"
++#else
++
+ .text
+ .globl jump_fcontext
+ .align 2
+@@ -73,3 +77,5 @@ jump_fcontext:
+ 
+ /* Mark that we don't need executable stack.  */
+ .section .note.GNU-stack,"",%progbits
++
++#endif
+--- a/libs/context/src/asm/make_i386_sysv_elf_gas.S
++++ b/libs/context/src/asm/make_i386_sysv_elf_gas.S
+@@ -31,6 +31,10 @@
+  *                                                                  *
+  * *****************************************************************/
+ 
++#ifdef __x86_64__
++#include "make_x86_64_sysv_elf_gas.S"
++#else
++
+ .text
+ .globl make_fcontext
+ .align 2
+@@ -78,3 +82,5 @@ finish:
+ 
+ /* Mark that we don't need executable stack.  */
+ .section .note.GNU-stack,"",%progbits
++
++#endif

diff --git a/dev-libs/boost/files/boost-1.55.0-tools-c98-compat.patch b/dev-libs/boost/files/boost-1.55.0-tools-c98-compat.patch
new file mode 100644
index 0000000..df2a14a
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.55.0-tools-c98-compat.patch
@@ -0,0 +1,17 @@
+Make tools compiled successfully with forced C++98
+
+Gentoo bugreport: https://bugs.gentoo.org/show_bug.cgi?id=503468
+
+diff --git a/tools/regression/src/compiler_status.cpp b/tools/regression/src/compiler_status.cpp
+index 63f8134..3f3374a 100644
+--- a/tools/regression/src/compiler_status.cpp
++++ b/tools/regression/src/compiler_status.cpp
+@@ -128,7 +128,7 @@ namespace
+         string ln(line);
+         if (ln.find("Revision: ") != string::npos)
+         {
+-          for(auto itr = ln.begin()+10; itr != ln.end() && isdigit(*itr); ++itr)
++          for(string::iterator itr = ln.begin()+10; itr != ln.end() && isdigit(*itr); ++itr)
+             rev += *itr;
+         }
+       }

diff --git a/dev-libs/boost/files/boost-1.56.0-build-auto_index-tool.patch b/dev-libs/boost/files/boost-1.56.0-build-auto_index-tool.patch
new file mode 100644
index 0000000..5175800
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.56.0-build-auto_index-tool.patch
@@ -0,0 +1,13 @@
+Build auto_index tool with USE="tools"
+Gentoo bug report: https://bugs.gentoo.org/show_bug.cgi?id=529066
+
+--- tools/Jamfile.v2.orig	2014-12-24 12:57:32.290880067 +0300
++++ tools/Jamfile.v2	2014-12-24 12:58:38.403883250 +0300
+@@ -20,6 +20,7 @@
+ use-project /boost/regression : regression/build ;
+ 
+ TOOLS =
++    auto_index/build//auto_index
+     bcp//bcp
+     inspect/build//inspect
+     quickbook//quickbook

diff --git a/dev-libs/boost/metadata.xml b/dev-libs/boost/metadata.xml
new file mode 100644
index 0000000..8e49be5
--- /dev/null
+++ b/dev-libs/boost/metadata.xml
@@ -0,0 +1,38 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+  <herd>cpp</herd>
+  <use>
+    <flag name="context">
+      Build and install the Boost.Context library and all other 
+      Boostlibraries that depends on it
+    </flag>
+    <flag name="tools">
+      Build and install the boost tools (bcp, quickbook, inspect,
+      wave)
+    </flag>
+    <flag name="debug" restrict="&lt;dev-libs/boost-1.50.0-r3">
+      Build and install debug versions of the Boost libraries. These
+      libraries are not used by default, and should not be used unless
+      you're developing against Boost.
+    </flag>
+    <flag name="debug" restrict="&gt;dev-libs/boost-1.52.0-r2">
+      Build and install only the debug version of the Boost
+      libraries. Only enable this flag if you're developing against
+      boost.
+    </flag>
+    <flag name="threads">
+      Build multi-thread-compatible libraries instead of
+      single-threaded only.
+    </flag>
+    <flag name="nls">
+      Build libboost_locale. This library requires compatible C
+      library interfaces, which might not be provided by uClibc or
+      other embedded libraries.
+    </flag>
+    <flag name="doc">
+      Install the full API documentation documentation. This takes
+      over 200MB of extra disk space.
+    </flag>
+  </use>
+</pkgmetadata>


^ permalink raw reply related	[flat|nested] 3+ messages in thread
* [gentoo-commits] proj/sci:master commit in: dev-libs/boost/, dev-libs/boost/files/
@ 2015-02-17  4:03 Christoph Junghans
  0 siblings, 0 replies; 3+ messages in thread
From: Christoph Junghans @ 2015-02-17  4:03 UTC (permalink / raw
  To: gentoo-commits

commit:     25058eb90fbb2a6c5eb23de9ce8386682fd14005
Author:     Christoph Junghans <ottxor <AT> gentoo <DOT> org>
AuthorDate: Tue Feb 17 04:03:02 2015 +0000
Commit:     Christoph Junghans <ottxor <AT> gentoo <DOT> org>
CommitDate: Tue Feb 17 04:03:02 2015 +0000
URL:        http://sources.gentoo.org/gitweb/?p=proj/sci.git;a=commit;h=25058eb9

added full multilib version

Package-Manager: portage-2.2.14

---
 dev-libs/boost/ChangeLog                           |  17 +
 dev-libs/boost/boost-1.56.0-r2.ebuild              | 398 +++++++++++++++++++++
 .../files/boost-1.48.0-disable_icu_rpath.patch     |  29 ++
 .../boost-1.48.0-disable_libboost_python3.patch    |  62 ++++
 .../boost-1.48.0-no_strict_aliasing_python2.patch  |  23 ++
 .../boost/files/boost-1.48.0-python_linking.patch  |  24 ++
 .../boost-1.51.0-respect_python-buildid.patch      |  69 ++++
 ...ost-1.51.0-support_dots_in_python-buildid.patch |  22 ++
 dev-libs/boost/files/boost-1.52.0-threads.patch    |  63 ++++
 .../boost/files/boost-1.55.0-context-x32.patch     |  42 +++
 .../files/boost-1.55.0-tools-c98-compat.patch      |  17 +
 .../files/boost-1.56.0-build-auto_index-tool.patch |  13 +
 dev-libs/boost/metadata.xml                        |  38 ++
 13 files changed, 817 insertions(+)

diff --git a/dev-libs/boost/ChangeLog b/dev-libs/boost/ChangeLog
new file mode 100644
index 0000000..893df76
--- /dev/null
+++ b/dev-libs/boost/ChangeLog
@@ -0,0 +1,17 @@
+# ChangeLog for dev-libs/boost
+# Copyright 1999-2015 Gentoo Foundation; Distributed under the GPL v2
+# $Header: $
+
+*boost-1.56.0-r2 (17 Feb 2015)
+
+  17 Feb 2015; Christoph Junghans <ottxor@gentoo.org> +boost-1.56.0-r2.ebuild,
+  +files/boost-1.48.0-disable_icu_rpath.patch,
+  +files/boost-1.48.0-disable_libboost_python3.patch,
+  +files/boost-1.48.0-no_strict_aliasing_python2.patch,
+  +files/boost-1.48.0-python_linking.patch,
+  +files/boost-1.51.0-respect_python-buildid.patch,
+  +files/boost-1.51.0-support_dots_in_python-buildid.patch,
+  +files/boost-1.52.0-threads.patch, +files/boost-1.55.0-context-x32.patch,
+  +files/boost-1.55.0-tools-c98-compat.patch,
+  +files/boost-1.56.0-build-auto_index-tool.patch, +metadata.xml:
+  added full multilib version

diff --git a/dev-libs/boost/boost-1.56.0-r2.ebuild b/dev-libs/boost/boost-1.56.0-r2.ebuild
new file mode 100644
index 0000000..e035399
--- /dev/null
+++ b/dev-libs/boost/boost-1.56.0-r2.ebuild
@@ -0,0 +1,398 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-libs/boost/boost-1.56.0-r1.ebuild,v 1.3 2015/01/05 17:58:25 ottxor Exp $
+
+EAPI="5"
+PYTHON_COMPAT=( python{2_7,3_2,3_3,3_4} )
+
+inherit eutils flag-o-matic multilib multiprocessing python-r1 toolchain-funcs versionator multilib-minimal
+
+MY_P="${PN}_$(replace_all_version_separators _)"
+MAJOR_V="$(get_version_component_range 1-2)"
+
+DESCRIPTION="Boost Libraries for C++"
+HOMEPAGE="http://www.boost.org/"
+SRC_URI="mirror://sourceforge/boost/${MY_P}.tar.bz2"
+
+LICENSE="Boost-1.0"
+SLOT="0/${PV}" # ${PV} instead ${MAJOR_V} due to bug 486122
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~ppc-aix ~amd64-fbsd ~x86-fbsd ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x86-solaris ~x86-winnt"
+
+IUSE="context debug doc icu +nls mpi python static-libs +threads tools"
+
+RDEPEND="abi_x86_32? ( !app-emulation/emul-linux-x86-cpplibs[-abi_x86_32(-)] )
+	icu? ( >=dev-libs/icu-3.6:=[${MULTILIB_USEDEP}] )
+	!icu? ( virtual/libiconv[${MULTILIB_USEDEP}] )
+	mpi? ( >=virtual/mpi-2.0-r4[${MULTILIB_USEDEP},cxx,threads] )
+	python? ( ${PYTHON_DEPS} )
+	app-arch/bzip2[${MULTILIB_USEDEP}]
+	sys-libs/zlib[${MULTILIB_USEDEP}]
+	!app-admin/eselect-boost"
+DEPEND="${RDEPEND}
+	=dev-util/boost-build-${MAJOR_V}*"
+REQUIRED_USE="
+	mpi? ( threads )
+	python? ( ${PYTHON_REQUIRED_USE} )"
+
+S="${WORKDIR}/${MY_P}"
+
+# the tests will never fail because these are not intended as sanity
+# tests at all. They are more a way for upstream to check their own code
+# on new compilers. Since they would either be completely unreliable
+# (failing for no good reason) or completely useless (never failing)
+# there is no point in having them in the ebuild to begin with.
+RESTRICT="test"
+
+python_bindings_needed() {
+	multilib_is_native_abi && use python
+}
+
+tools_needed() {
+	multilib_is_native_abi && use tools
+}
+
+create_user-config.jam() {
+	local compiler compiler_version compiler_executable
+
+	if [[ ${CHOST} == *-darwin* ]]; then
+		compiler="darwin"
+		compiler_version="$(gcc-fullversion)"
+		compiler_executable="$(tc-getCXX)"
+	else
+		compiler="gcc"
+		compiler_version="$(gcc-version)"
+		compiler_executable="$(tc-getCXX)"
+	fi
+	local mpi_configuration python_configuration
+
+	if use mpi; then
+		mpi_configuration="using mpi ;"
+	fi
+
+	if python_bindings_needed; then
+		if tc-is-cross-compiler; then
+			python_configuration="using python : ${EPYTHON#python} : : ${SYSROOT:-${EROOT}}/usr/include/${EPYTHON} : ${SYSROOT:-${EROOT}}/usr/$(get_libdir) ;"
+		else
+			python_configuration="using python : : ${PYTHON} ;"
+		fi
+	fi
+
+	cat > "${BOOST_ROOT}/user-config.jam" << __EOF__
+using ${compiler} : ${compiler_version} : ${compiler_executable} : <cflags>"${CFLAGS}" <cxxflags>"${CXXFLAGS}" <linkflags>"${LDFLAGS}" ;
+${mpi_configuration}
+${python_configuration}
+__EOF__
+}
+
+pkg_setup() {
+	# Bail out on unsupported build configuration, bug #456792
+	if [[ -f "${EROOT}etc/site-config.jam" ]]; then
+		grep -q gentoorelease "${EROOT}etc/site-config.jam" && grep -q gentoodebug "${EROOT}etc/site-config.jam" ||
+		(
+			eerror "You are using custom ${EROOT}etc/site-config.jam without defined gentoorelease/gentoodebug targets."
+			eerror "Boost can not be built in such configuration."
+			eerror "Please, either remove this file or add targets from ${EROOT}usr/share/boost-build/site-config.jam to it."
+			die
+		)
+	fi
+}
+
+src_prepare() {
+	epatch \
+		"${FILESDIR}/${PN}-1.51.0-respect_python-buildid.patch" \
+		"${FILESDIR}/${PN}-1.51.0-support_dots_in_python-buildid.patch" \
+		"${FILESDIR}/${PN}-1.48.0-no_strict_aliasing_python2.patch" \
+		"${FILESDIR}/${PN}-1.48.0-disable_libboost_python3.patch" \
+		"${FILESDIR}/${PN}-1.48.0-python_linking.patch" \
+		"${FILESDIR}/${PN}-1.48.0-disable_icu_rpath.patch" \
+		"${FILESDIR}/${PN}-1.55.0-context-x32.patch" \
+		"${FILESDIR}/${PN}-1.55.0-tools-c98-compat.patch" \
+		"${FILESDIR}/${PN}-1.52.0-threads.patch" \
+		"${FILESDIR}/${PN}-1.56.0-build-auto_index-tool.patch"
+
+	# Do not try to build missing 'wave' tool, bug #522682
+	# Upstream bugreport - https://svn.boost.org/trac/boost/ticket/10507
+	sed -i -e 's:wave/build//wave::' tools/Jamfile.v2 || die
+
+	epatch_user
+
+	multilib_copy_sources
+}
+
+ejam() {
+	local b2_opts="--user-config=${BOOST_ROOT}/user-config.jam $@"
+	echo b2 ${b2_opts}
+	b2 ${b2_opts}
+}
+
+src_configure() {
+	# Workaround for too many parallel processes requested, bug #506064
+	[ "$(makeopts_jobs)" -gt 64 ] && MAKEOPTS="${MAKEOPTS} -j64"
+
+	OPTIONS="$(usex debug gentoodebug gentoorelease) -j$(makeopts_jobs) -q -d+2"
+
+	if [[ ${CHOST} == *-darwin* ]]; then
+		# We need to add the prefix, and in two cases this exceeds, so prepare
+		# for the largest possible space allocation.
+		append-ldflags -Wl,-headerpad_max_install_names
+	elif [[ ${CHOST} == *-winnt* ]]; then
+		compiler=parity
+		if [[ $($(tc-getCXX) -v) == *trunk* ]]; then
+			compilerVersion=trunk
+		else
+			compilerVersion=$($(tc-getCXX) -v | sed '1q' \
+				| sed -e 's,\([a-z]*\) \([0-9]\.[0-9]\.[0-9][^ \t]*\) .*,\2,')
+		fi
+		compilerExecutable=$(tc-getCXX)
+	fi
+
+	# bug 298489
+	if use ppc || use ppc64; then
+		[[ $(gcc-version) > 4.3 ]] && append-flags -mno-altivec
+	fi
+
+	# Do _not_ use C++11 yet, make sure to force GNU C++ 98 standard.
+	append-cxxflags -std=gnu++98
+
+	use icu && OPTIONS+=" -sICU_PATH=${EPREFIX}/usr"
+	use icu || OPTIONS+=" --disable-icu boost.locale.icu=off"
+	use mpi || OPTIONS+=" --without-mpi"
+	use nls || OPTIONS+=" --without-locale"
+	use context || OPTIONS+=" --without-context --without-coroutine"
+
+	OPTIONS+=" pch=off"
+	OPTIONS+=" --boost-build=${EPREFIX}/usr/share/boost-build --prefix=\"${ED}usr\""
+	OPTIONS+=" --layout=system"
+	OPTIONS+=" threading=$(usex threads multi single) link=$(usex static-libs shared,static shared)"
+
+	[[ ${CHOST} == *-winnt* ]] && OPTIONS+=" -sNO_BZIP2=1"
+}
+
+multilib_src_compile() {
+	local -x BOOST_ROOT="${BUILD_DIR}"
+	PYTHON_DIRS=""
+	MPI_PYTHON_MODULE=""
+
+	building() {
+		create_user-config.jam
+
+		local PYTHON_OPTIONS
+		if python_bindings_needed; then
+			PYTHON_OPTIONS=" --python-buildid=${EPYTHON#python}"
+		else
+			PYTHON_OPTIONS=" --without-python"
+		fi
+
+		ejam \
+			${OPTIONS} \
+			${PYTHON_OPTIONS} \
+			|| die "Building of Boost libraries failed"
+
+		if python_bindings_needed; then
+			if [[ -z "${PYTHON_DIRS}" ]]; then
+				PYTHON_DIRS="$(find bin.v2/libs -name python | sort)"
+			else
+				if [[ "${PYTHON_DIRS}" != "$(find bin.v2/libs -name python | sort)" ]]; then
+					die "Inconsistent structure of build directories"
+				fi
+			fi
+
+			local dir
+			for dir in ${PYTHON_DIRS}; do
+				mv ${dir} ${dir}-${EPYTHON} \
+					|| die "Renaming of '${dir}' to '${dir}-${EPYTHON}' failed"
+			done
+
+			if use mpi; then
+				if [[ -z "${MPI_PYTHON_MODULE}" ]]; then
+					MPI_PYTHON_MODULE="$(find bin.v2/libs/mpi/build/*/gentoo* -name mpi.so)"
+					if [[ "$(echo "${MPI_PYTHON_MODULE}" | wc -l)" -ne 1 ]]; then
+						die "Multiple mpi.so files found"
+					fi
+				else
+					if [[ "${MPI_PYTHON_MODULE}" != "$(find bin.v2/libs/mpi/build/*/gentoo* -name mpi.so)" ]]; then
+						die "Inconsistent structure of build directories"
+					fi
+				fi
+
+				mv stage/lib/mpi.so stage/lib/mpi.so-${EPYTHON} \
+					|| die "Renaming of 'stage/lib/mpi.so' to 'stage/lib/mpi.so-${EPYTHON}' failed"
+			fi
+		fi
+	}
+	if python_bindings_needed; then
+		python_foreach_impl building
+	else
+		building
+	fi
+
+	if tools_needed; then
+		pushd tools > /dev/null || die
+
+		ejam \
+			${OPTIONS} \
+			${PYTHON_OPTIONS} \
+			|| die "Building of Boost tools failed"
+		popd > /dev/null || die
+	fi
+}
+
+multilib_src_install_all() {
+	if ! use python; then
+		rm -r "${ED}"/usr/include/boost/python* || die
+	fi
+
+	if ! use nls; then
+		rm -r "${ED}"/usr/include/boost/locale || die
+	fi
+
+	if ! use context; then
+		rm -r "${ED}"/usr/include/boost/context || die
+		rm -r "${ED}"/usr/include/boost/coroutine || die
+	fi
+
+	if use doc; then
+		find libs/*/* -iname "test" -or -iname "src" | xargs rm -rf
+		dohtml \
+			-A pdf,txt,cpp,hpp \
+			*.{htm,html,png,css} \
+			-r doc
+		dohtml -A pdf,txt -r tools
+		insinto /usr/share/doc/${PF}/html
+		doins -r libs
+		doins -r more
+
+		# To avoid broken links
+		insinto /usr/share/doc/${PF}/html
+		doins LICENSE_1_0.txt
+
+		dosym /usr/include/boost /usr/share/doc/${PF}/html/boost
+	fi
+}
+
+multilib_src_install() {
+	local -x BOOST_ROOT="${BUILD_DIR}"
+	installation() {
+		create_user-config.jam
+
+		local PYTHON_OPTIONS
+		if python_bindings_needed; then
+			local dir
+			for dir in ${PYTHON_DIRS}; do
+				cp -pr ${dir}-${EPYTHON} ${dir} \
+					|| die "Copying of '${dir}-${EPYTHON}' to '${dir}' failed"
+			done
+
+			if use mpi; then
+				cp -p stage/lib/mpi.so-${EPYTHON} "${MPI_PYTHON_MODULE}" \
+					|| die "Copying of 'stage/lib/mpi.so-${EPYTHON}' to '${MPI_PYTHON_MODULE}' failed"
+				cp -p stage/lib/mpi.so-${EPYTHON} stage/lib/mpi.so \
+					|| die "Copying of 'stage/lib/mpi.so-${EPYTHON}' to 'stage/lib/mpi.so' failed"
+			fi
+			PYTHON_OPTIONS=" --python-buildid=${EPYTHON#python}"
+		else
+			PYTHON_OPTIONS=" --without-python"
+		fi
+
+		ejam \
+			${OPTIONS} \
+			${PYTHON_OPTIONS} \
+			--includedir="${ED}usr/include" \
+			--libdir="${ED}usr/$(get_libdir)" \
+			install || die "Installation of Boost libraries failed"
+
+		if python_bindings_needed; then
+			rm -r ${PYTHON_DIRS} || die
+
+			# Move mpi.so Python module to Python site-packages directory.
+			# https://svn.boost.org/trac/boost/ticket/2838
+			if use mpi; then
+				local moddir=$(python_get_sitedir)/boost
+				# moddir already includes eprefix
+				mkdir -p "${D}${moddir}" || die
+				mv "${ED}usr/$(get_libdir)/mpi.so" "${D}${moddir}" || die
+				cat << EOF > "${D}${moddir}/__init__.py" || die
+import sys
+if sys.platform.startswith('linux'):
+	import DLFCN
+	flags = sys.getdlopenflags()
+	sys.setdlopenflags(DLFCN.RTLD_NOW | DLFCN.RTLD_GLOBAL)
+	from . import mpi
+	sys.setdlopenflags(flags)
+	del DLFCN, flags
+else:
+	from . import mpi
+del sys
+EOF
+			fi
+
+			python_optimize
+		fi
+	}
+	if python_bindings_needed; then
+		python_foreach_impl installation
+	else
+		installation
+	fi
+
+	pushd "${ED}usr/$(get_libdir)" > /dev/null || die
+
+	local ext=$(get_libname)
+	if use threads; then
+		local f
+		for f in *${ext}; do
+			dosym ${f} /usr/$(get_libdir)/${f/${ext}/-mt${ext}}
+		done
+	fi
+
+	popd > /dev/null || die
+
+	if tools_needed; then
+		dobin dist/bin/*
+
+		insinto /usr/share
+		doins -r dist/share/boostbook
+	fi
+
+	# boost's build system truely sucks for not having a destdir.  Because for
+	# this reason we are forced to build with a prefix that includes the
+	# DESTROOT, dynamic libraries on Darwin end messed up, referencing the
+	# DESTROOT instread of the actual EPREFIX.  There is no way out of here
+	# but to do it the dirty way of manually setting the right install_names.
+	if [[ ${CHOST} == *-darwin* ]]; then
+		einfo "Working around completely broken build-system(tm)"
+		local d
+		for d in "${ED}"usr/lib/*.dylib; do
+			if [[ -f ${d} ]]; then
+				# fix the "soname"
+				ebegin "  correcting install_name of ${d#${ED}}"
+				install_name_tool -id "/${d#${D}}" "${d}"
+				eend $?
+				# fix references to other libs
+				refs=$(otool -XL "${d}" | \
+					sed -e '1d' -e 's/^\t//' | \
+					grep "^libboost_" | \
+					cut -f1 -d' ')
+				local r
+				for r in ${refs}; do
+					ebegin "    correcting reference to ${r}"
+					install_name_tool -change \
+						"${r}" \
+						"${EPREFIX}/usr/lib/${r}" \
+						"${d}"
+					eend $?
+				done
+			fi
+		done
+	fi
+}
+
+pkg_preinst() {
+	# Yai for having symlinks that are nigh-impossible to remove without
+	# resorting to dirty hacks like these. Removes lingering symlinks
+	# from the slotted versions.
+	local symlink
+	for symlink in "${EROOT}usr/include/boost" "${EROOT}usr/share/boostbook"; do
+		[[ -L ${symlink} ]] && rm -f "${symlink}"
+	done
+}

diff --git a/dev-libs/boost/files/boost-1.48.0-disable_icu_rpath.patch b/dev-libs/boost/files/boost-1.48.0-disable_icu_rpath.patch
new file mode 100644
index 0000000..a902d61
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.48.0-disable_icu_rpath.patch
@@ -0,0 +1,29 @@
+--- libs/locale/build/Jamfile.v2
++++ libs/locale/build/Jamfile.v2
+@@ -58,8 +58,8 @@
+ 
+ if $(ICU_LINK)
+ {
+-    ICU_OPTS = <include>$(ICU_PATH)/include <linkflags>$(ICU_LINK) <dll-path>$(ICU_PATH)/bin <runtime-link>shared ;
+-    ICU64_OPTS = <include>$(ICU_PATH)/include <linkflags>$(ICU_LINK) <dll-path>$(ICU_PATH)/bin64 <runtime-link>shared ;
++    ICU_OPTS = <include>$(ICU_PATH)/include <linkflags>$(ICU_LINK) <runtime-link>shared ;
++    ICU64_OPTS = <include>$(ICU_PATH)/include <linkflags>$(ICU_LINK) <runtime-link>shared ;
+ }
+ else
+ {
+@@ -117,7 +117,6 @@
+       <library>icuuc/<link>shared/<runtime-link>shared 
+       <library>icudt/<link>shared/<runtime-link>shared 
+       <library>icuin/<link>shared/<runtime-link>shared
+-      <dll-path>$(ICU_PATH)/bin
+         <runtime-link>shared ;
+ 
+ 
+@@ -176,7 +175,6 @@
+       <library>icuuc_64/<link>shared/<runtime-link>shared 
+       <library>icudt_64/<link>shared/<runtime-link>shared 
+       <library>icuin_64/<link>shared/<runtime-link>shared
+-      <dll-path>$(ICU_PATH)/bin64
+         <runtime-link>shared ;
+  
+     

diff --git a/dev-libs/boost/files/boost-1.48.0-disable_libboost_python3.patch b/dev-libs/boost/files/boost-1.48.0-disable_libboost_python3.patch
new file mode 100644
index 0000000..c24a56c
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.48.0-disable_libboost_python3.patch
@@ -0,0 +1,62 @@
+--- libs/python/build/Jamfile.v2
++++ libs/python/build/Jamfile.v2
+@@ -39,23 +39,6 @@
+     PYTHON_ID = [ regex.replace $(python-id) "[*\\/:\"\']" "_" ] ;
+ }
+ 
+-
+-rule find-py3-version
+-{
+-    local versions = [ feature.values python ] ;
+-    local py3ver ;
+-    for local v in $(versions)
+-    {
+-        if $(v) >= 3.0
+-        {
+-            py3ver = $(v) ;
+-        }
+-    }
+-    return $(py3ver) ;
+-}
+-
+-py3-version = [ find-py3-version ] ;
+-
+ project boost/python
+   : source-location ../src
+   : requirements
+@@ -82,7 +65,7 @@
+ rule cond ( test ? : yes * : no * ) { if $(test) { return $(yes) ; } else { return $(no) ; } }
+ rule unless ( test ? : yes * : no * ) { if ! $(test) { return $(yes) ; } else { return $(no) ; } }
+ 
+-rule lib_boost_python ( is-py3 ? )
++rule lib_boost_python
+ {
+ 
+     local python_major_version = [ MATCH "^([^.]+)" : [ feature.values python ] ] ;
+@@ -91,7 +74,7 @@
+     {
+         python2 = true ;
+     }
+-    lib [ cond $(is-py3) : boost_python3 : boost_python ]
++    lib boost_python
+         : # sources
+         numeric.cpp
+         list.cpp
+@@ -148,7 +131,6 @@
+             <dependency>config-warning
+ 
+             <python-debugging>on:<define>BOOST_DEBUG_PYTHON
+-            [ cond $(is-py3) : <python>$(py3-version) ]
+         :   # default build
+             <link>shared
+         :   # usage requirements
+@@ -160,9 +142,3 @@
+ 
+ lib_boost_python ;
+ boost-install boost_python ;
+-
+-if $(py3-version)
+-{
+-    lib_boost_python yes ;
+-    boost-install boost_python3 ;
+-}

diff --git a/dev-libs/boost/files/boost-1.48.0-no_strict_aliasing_python2.patch b/dev-libs/boost/files/boost-1.48.0-no_strict_aliasing_python2.patch
new file mode 100644
index 0000000..89f8109
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.48.0-no_strict_aliasing_python2.patch
@@ -0,0 +1,23 @@
+--- libs/python/build/Jamfile.v2
++++ libs/python/build/Jamfile.v2
+@@ -85,6 +85,12 @@
+ rule lib_boost_python ( is-py3 ? )
+ {
+ 
++    local python_major_version = [ MATCH "^([^.]+)" : [ feature.values python ] ] ;
++    local python2 ;
++    if $(python_major_version) = 2
++    {
++        python2 = true ;
++    }
+     lib [ cond $(is-py3) : boost_python3 : boost_python ]
+         : # sources
+         numeric.cpp
+@@ -119,6 +125,7 @@
+         :   # requirements
+             <link>static:<define>BOOST_PYTHON_STATIC_LIB 
+             <define>BOOST_PYTHON_SOURCE
++            [ cond $(python2) : <cxxflags>-fno-strict-aliasing ]
+           
+             # On Windows, all code using Python has to link to the Python
+             # import library.

diff --git a/dev-libs/boost/files/boost-1.48.0-python_linking.patch b/dev-libs/boost/files/boost-1.48.0-python_linking.patch
new file mode 100644
index 0000000..e7f4e7c
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.48.0-python_linking.patch
@@ -0,0 +1,24 @@
+--- libs/python/build/Jamfile.v2
++++ libs/python/build/Jamfile.v2
+@@ -109,20 +109,7 @@
+             <link>static:<define>BOOST_PYTHON_STATIC_LIB 
+             <define>BOOST_PYTHON_SOURCE
+             [ cond $(python2) : <cxxflags>-fno-strict-aliasing ]
+-          
+-            # On Windows, all code using Python has to link to the Python
+-            # import library.
+-            #
+-            # On *nix we never link libboost_python to libpython.  When
+-            # extending Python, all Python symbols are provided by the
+-            # Python interpreter executable.  When embedding Python, the
+-            # client executable is expected to explicitly link to
+-            # /python//python (the target representing libpython) itself.
+-            #
+-            # python_for_extensions is a target defined by Boost.Build to
+-            # provide the Python include paths, and on Windows, the Python
+-            # import library, as usage requirements.
+-            [ cond [ python.configured ] : <library>/python//python_for_extensions ]
++            [ cond [ python.configured ] : <library>/python//python ]
+             
+             # we prevent building when there is no python available
+             # as it's not possible anyway, and to cause dependents to

diff --git a/dev-libs/boost/files/boost-1.51.0-respect_python-buildid.patch b/dev-libs/boost/files/boost-1.51.0-respect_python-buildid.patch
new file mode 100644
index 0000000..327429e
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.51.0-respect_python-buildid.patch
@@ -0,0 +1,69 @@
+https://svn.boost.org/trac/boost/ticket/6286
+
+--- boostcpp.jam
++++ boostcpp.jam
+@@ -99,13 +99,6 @@
+     BUILD_ID = [ regex.replace $(build-id) "[*\\/:.\"\' ]" _ ] ;
+ }
+ 
+-# Python build id (for Python libraries only).
+-python-id = [ option.get "python-buildid" ] ;
+-if $(python-id)
+-{
+-    PYTHON_ID = [ regex.replace $(python-id) [*\\/:.\"\'] _ ] ;
+-}
+-
+ 
+ ################################################################################
+ #
+--- libs/mpi/build/Jamfile.v2
++++ libs/mpi/build/Jamfile.v2
+@@ -8,6 +8,8 @@
+ #  Authors: Douglas Gregor
+ #           Andrew Lumsdaine
+ 
++import option ;
++import regex ;
+ import mpi ;
+ import indirect ;
+ import python ;
+@@ -24,6 +26,13 @@
+     <tag>@$(__name__).tag
+   ;
+ 
++# Python build id (for Python libraries only).
++python-id = [ option.get "python-buildid" ] ;
++if $(python-id)
++{
++    PYTHON_ID = [ regex.replace $(python-id) [*\\/:.\"\'] _ ] ;
++}
++
+ rule tag ( name : type ? : property-set )
+ {
+     local result = $(name) ;
+--- libs/python/build/Jamfile.v2
++++ libs/python/build/Jamfile.v2
+@@ -2,6 +2,8 @@
+ # Software License, Version 1.0. (See accompanying
+ # file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)
+ 
++import option ;
++import regex ;
+ import os ;
+ import indirect ;
+ import modules ;
+@@ -30,6 +32,14 @@
+         ;
+ }
+ 
++# Python build id (for Python libraries only).
++python-id = [ option.get "python-buildid" ] ;
++if $(python-id)
++{
++    PYTHON_ID = [ regex.replace $(python-id) [*\\/:.\"\'] _ ] ;
++}
++
++
+ rule find-py3-version
+ {
+     local versions = [ feature.values python ] ;

diff --git a/dev-libs/boost/files/boost-1.51.0-support_dots_in_python-buildid.patch b/dev-libs/boost/files/boost-1.51.0-support_dots_in_python-buildid.patch
new file mode 100644
index 0000000..c8dc6e1
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.51.0-support_dots_in_python-buildid.patch
@@ -0,0 +1,22 @@
+--- libs/mpi/build/Jamfile.v2
++++ libs/mpi/build/Jamfile.v2
+@@ -30,7 +30,7 @@
+ python-id = [ option.get "python-buildid" ] ;
+ if $(python-id)
+ {
+-    PYTHON_ID = [ regex.replace $(python-id) [*\\/:.\"\'] _ ] ;
++    PYTHON_ID = [ regex.replace $(python-id) [*\\/:\"\'] _ ] ;
+ }
+ 
+ rule tag ( name : type ? : property-set )
+--- libs/python/build/Jamfile.v2
++++ libs/python/build/Jamfile.v2
+@@ -36,7 +36,7 @@
+ python-id = [ option.get "python-buildid" ] ;
+ if $(python-id)
+ {
+-    PYTHON_ID = [ regex.replace $(python-id) [*\\/:.\"\'] _ ] ;
++    PYTHON_ID = [ regex.replace $(python-id) [*\\/:\"\'] _ ] ;
+ }
+ 
+ 

diff --git a/dev-libs/boost/files/boost-1.52.0-threads.patch b/dev-libs/boost/files/boost-1.52.0-threads.patch
new file mode 100644
index 0000000..e078fc2
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.52.0-threads.patch
@@ -0,0 +1,63 @@
+Index: /trunk/boostcpp.jam
+===================================================================
+--- /trunk/boostcpp.jam	(revision 79301)
++++ /trunk/boostcpp.jam	(revision 81000)
+@@ -210,6 +210,44 @@
+ }
+ 
++rule filtered-target ( name : message + : sources + : requirements * )
++{
++    message $(name)-message : warning: $(message) ;
++    alias $(name) : $(sources) : $(requirements) ;
++    alias $(name) : $(name)-message ;
++
++    local p = [ project.current ] ;
++    $(p).mark-target-as-explicit $(name) ;
++    $(p).mark-target-as-explicit $(name)-message ;
++}
++
+ rule declare_install_and_stage_proper_targets ( libraries * : headers * )
+ {
++    for local l in $(libraries)
++    {
++        if $(l) = locale
++        {
++            filtered-target $(l)-for-install :
++                Skipping Boost.Locale library with threading=single. :
++                libs/$(l)/build : <threading>multi ;
++        }
++        else if $(l) = wave
++        {
++            filtered-target $(l)-for-install :
++                Skipping Boost.Wave library with threading=single. :
++                libs/$(l)/build : <threading>multi ;
++        }
++        else if $(l) = thread
++        {
++            filtered-target $(l)-for-install :
++                Skipping Boost.Thread library with threading=single. :
++                libs/$(l)/build : <threading>multi ;
++        }
++        else
++        {
++            alias $(l)-for-install : libs/$(l)/build ; 
++        }
++    }
++    local library-targets = $(libraries)-for-install ;
++
+     install-requirements = <install-source-root>$(BOOST_ROOT)/boost ;
+ 
+@@ -239,5 +277,5 @@
+         : $(install-requirements) <install-no-version-symlinks>on
+         :
+-        : libs/$(libraries)/build
++        : $(libraries)-for-install
+         : $(headers)
+         ;
+@@ -246,5 +284,5 @@
+     # Install just library.
+     install stage-proper
+-        : libs/$(libraries)/build
++        : $(libraries)-for-install
+         : <location>$(stage-locate)/lib
+           <install-dependencies>on <install-type>LIB

diff --git a/dev-libs/boost/files/boost-1.55.0-context-x32.patch b/dev-libs/boost/files/boost-1.55.0-context-x32.patch
new file mode 100644
index 0000000..5bf7406
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.55.0-context-x32.patch
@@ -0,0 +1,42 @@
+https://svn.boost.org/trac/boost/ticket/9445
+
+hack to fix x32 builds
+
+--- a/libs/context/src/asm/jump_i386_sysv_elf_gas.S
++++ b/libs/context/src/asm/jump_i386_sysv_elf_gas.S
+@@ -31,6 +31,10 @@
+  *                                                                  *
+  * *****************************************************************/
+ 
++#ifdef __x86_64__
++#include "jump_x86_64_sysv_elf_gas.S"
++#else
++
+ .text
+ .globl jump_fcontext
+ .align 2
+@@ -73,3 +77,5 @@ jump_fcontext:
+ 
+ /* Mark that we don't need executable stack.  */
+ .section .note.GNU-stack,"",%progbits
++
++#endif
+--- a/libs/context/src/asm/make_i386_sysv_elf_gas.S
++++ b/libs/context/src/asm/make_i386_sysv_elf_gas.S
+@@ -31,6 +31,10 @@
+  *                                                                  *
+  * *****************************************************************/
+ 
++#ifdef __x86_64__
++#include "make_x86_64_sysv_elf_gas.S"
++#else
++
+ .text
+ .globl make_fcontext
+ .align 2
+@@ -78,3 +82,5 @@ finish:
+ 
+ /* Mark that we don't need executable stack.  */
+ .section .note.GNU-stack,"",%progbits
++
++#endif

diff --git a/dev-libs/boost/files/boost-1.55.0-tools-c98-compat.patch b/dev-libs/boost/files/boost-1.55.0-tools-c98-compat.patch
new file mode 100644
index 0000000..df2a14a
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.55.0-tools-c98-compat.patch
@@ -0,0 +1,17 @@
+Make tools compiled successfully with forced C++98
+
+Gentoo bugreport: https://bugs.gentoo.org/show_bug.cgi?id=503468
+
+diff --git a/tools/regression/src/compiler_status.cpp b/tools/regression/src/compiler_status.cpp
+index 63f8134..3f3374a 100644
+--- a/tools/regression/src/compiler_status.cpp
++++ b/tools/regression/src/compiler_status.cpp
+@@ -128,7 +128,7 @@ namespace
+         string ln(line);
+         if (ln.find("Revision: ") != string::npos)
+         {
+-          for(auto itr = ln.begin()+10; itr != ln.end() && isdigit(*itr); ++itr)
++          for(string::iterator itr = ln.begin()+10; itr != ln.end() && isdigit(*itr); ++itr)
+             rev += *itr;
+         }
+       }

diff --git a/dev-libs/boost/files/boost-1.56.0-build-auto_index-tool.patch b/dev-libs/boost/files/boost-1.56.0-build-auto_index-tool.patch
new file mode 100644
index 0000000..5175800
--- /dev/null
+++ b/dev-libs/boost/files/boost-1.56.0-build-auto_index-tool.patch
@@ -0,0 +1,13 @@
+Build auto_index tool with USE="tools"
+Gentoo bug report: https://bugs.gentoo.org/show_bug.cgi?id=529066
+
+--- tools/Jamfile.v2.orig	2014-12-24 12:57:32.290880067 +0300
++++ tools/Jamfile.v2	2014-12-24 12:58:38.403883250 +0300
+@@ -20,6 +20,7 @@
+ use-project /boost/regression : regression/build ;
+ 
+ TOOLS =
++    auto_index/build//auto_index
+     bcp//bcp
+     inspect/build//inspect
+     quickbook//quickbook

diff --git a/dev-libs/boost/metadata.xml b/dev-libs/boost/metadata.xml
new file mode 100644
index 0000000..03f221b
--- /dev/null
+++ b/dev-libs/boost/metadata.xml
@@ -0,0 +1,38 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+  <herd>cpp</herd>
+  <use>
+    <flag name='context'>
+      Build and install the Boost.Context library and all other 
+      Boostlibraries that depends on it
+    </flag>
+    <flag name='tools'>
+      Build and install the boost tools (bcp, quickbook, inspect,
+      wave)
+    </flag>
+    <flag name='debug' restrict='&lt;dev-libs/boost-1.50.0-r3'>
+      Build and install debug versions of the Boost libraries. These
+      libraries are not used by default, and should not be used unless
+      you're developing against Boost.
+    </flag>
+    <flag name='debug' restrict='&gt;dev-libs/boost-1.52.0-r2'>
+      Build and install only the debug version of the Boost
+      libraries. Only enable this flag if you're developing against
+      boost.
+    </flag>
+    <flag name='threads'>
+      Build multi-thread-compatible libraries instead of
+      single-threaded only.
+    </flag>
+    <flag name='nls'>
+      Build libboost_locale. This library requires compatible C
+      library interfaces, which might not be provided by uClibc or
+      other embedded libraries.
+    </flag>
+    <flag name='doc'>
+      Install the full API documentation documentation. This takes
+      over 200MB of extra disk space.
+    </flag>
+  </use>
+</pkgmetadata>


^ permalink raw reply related	[flat|nested] 3+ messages in thread

end of thread, other threads:[~2021-01-20 16:11 UTC | newest]

Thread overview: 3+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2021-01-20 16:11 [gentoo-commits] proj/sci:master commit in: dev-libs/boost/, dev-libs/boost/files/ Benda XU
  -- strict thread matches above, loose matches on Subject: below --
2015-04-18 16:27 Christoph Junghans
2015-02-17  4:03 Christoph Junghans

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox